	AREA |.text|, CODE

	IMPORT |Load$$ITCM$$Base|
	IMPORT |Image$$ITCM$$Base|
	IMPORT |Image$$ITCM$$Limit|
	IMPORT |Image$$ITCM$$Length|
	
	IMPORT |Load$$DTCM$$Base|
	IMPORT |Image$$DTCM$$Base|
	IMPORT |Image$$DTCM$$Limit|
	IMPORT |Image$$DTCM$$Length|
	
	IMPORT |Image$$EWRAM$$ZI$$Base|
	IMPORT |Image$$EWRAM$$ZI$$Limit|
	IMPORT |Image$$EWRAM$$ZI$$Length|
	
	IMPORT exception
	IMPORT arm9main
;-------------------------------
	ENTRY

arm9init
	mov r0,#0x4000000
	mov r1,#0x4000
	str r0,[r0,#0x208]	;IME=0
	str r1,[r0,#0x204]	;get EWRAM priority and cart access

	bl initmem		;setup mem regions, cache, etc
	
	mrc p15,0,r0,c9,c1,0
	bic r0,r0,#0xff
	add r0,r0,#0x4000	;(DTCM end)
	msr cpsr_c,#0x13
	sub sp,r0,#0x40		;SVC (swi) stack
	msr cpsr_c,#0x12
	sub sp,r0,#0x80		;IRQ stack
	msr cpsr_c,#0x1f
	sub sp,r0,#0x100	;user stack

	adr r5,copylist
	bl copy			;DTCM
	bl copy			;ITCM
	bl copy			;ZINIT

	ldr r0,=0x27ffd9c
	ldr r1,=exceptionhandler
	str r1,[r0]			;use arm9 exception handler (handy for catching bugs)

	ldr pc,=arm9main

copy
	ldmia r5!,{r0-r3}
copy2	cmp r1,r2
	ldrcc r4,[r0],r3
	strcc r4,[r1],#4
	bcc copy2
	bx lr
copylist
	dcd |Load$$DTCM$$Base|, |Image$$DTCM$$Base|, |Image$$DTCM$$Limit|, 4
	dcd |Load$$ITCM$$Base|, |Image$$ITCM$$Base|, |Image$$ITCM$$Limit|, 4
	dcd zero, |Image$$EWRAM$$ZI$$Base|, |Image$$EWRAM$$ZI$$Limit|
zero	dcd 0
;-------------------------------
initmem
	adr r12,memconfig
	
	ldr r0,=0x00002078
	mcr p15,0,r0,c1,c0,0	;cache+TCM+PU off
	
	ldmia r12!,{r0-r7}
	mcr p15,0,r0,c6,c0	;regions
	mcr p15,0,r1,c6,c1
	mcr p15,0,r2,c6,c2
	mcr p15,0,r3,c6,c3
	mcr p15,0,r4,c6,c4
	mcr p15,0,r5,c6,c5
	mcr p15,0,r6,c6,c6
	mcr p15,0,r7,c6,c7
	
	ldmia r12!,{r0-r6}
	mcr p15,0,r0,c2,c0,0	;cache data
	mcr p15,0,r1,c3,c0,0	;buffer data
	mcr p15,0,r2,c2,c0,1	;cache inst
	mcr p15,0,r3,c5,c0,2	;data access
	mcr p15,0,r4,c5,c0,3	;inst access
	mcr p15,0,r5,c9,c1,0	;dtcm base
	mcr p15,0,r6,c9,c1,1	;itcm base
	
	;ldr r0,=0x00052078
	ldr r0,=0x0005707d
	mcr p15,0,r0,c1,c0,0	;cache+TCM+PU on
	mov r0,#0
	mcr p15,0,r0,c7,c5,0	;icache flush
	mcr p15,0,r0,c7,c6,0	;dcache flush
	mov pc,lr
	
memconfig
	dcd 0x01ff801d	;->2000000 (32K) ITCM
	dcd 0x0200002b	;->2400000 (4M) main
	dcd 0x04000033	;->8000000 (64M) regs
	dcd 0x08000031	;->a000000 (32M) cart
	dcd 0xffff0017	;->ffff1000 (4K) bios
	dcd 0x0240002b	;->2800000 (4M) main (uncached)
	dcd 0x0280001b	;(16K) DTCM
	dcd 0x0a00001f	;(64k) SRAM

	dcd 2_00000010	;data cache
	dcd 2_00000010	;data buffer
	dcd 2_00000010	;inst cache
	dcd 0x33363333	;data access (0=NA, 3=RW, 6=R)
	dcd 0x00063033	;inst access
	dcd 0x0280000a	;(16K) DTCM base
	dcd 0x00000020	;->2000000 (32M) ITCM base
;--------------------------------
exceptionhandler
	stmfd sp!,{r0-r11,lr}
	mrs r1,cpsr		;r1=current mode (exception type)
	msr cpsr_c,#0xdf
	mov r2,sp
	mov r3,lr		;get old sp,lr
	msr cpsr_c,r1
	stmfd sp!,{r2,r3}
	bic r0,sp,#1
	bl exception
	add sp,sp,#8
	ldmfd sp!,{r0-r11,pc}
;-----------------------
	AREA itcm, CODE
	EXPORT __rt_sdiv
__rt_sdiv
	mov r2,#0x4000000
	mov r3,#0
	str r3,[r2,#0x280]!	;divcnt
	str r1,[r2,#0x10]
	str r3,[r2,#0x1c]
	str r0,[r2,#0x18]
divbusy
	ldr r0,[r2]
	tst r0,#0x8000
	bne divbusy
	ldr r0,[r2,#0x20]	;result
	ldr r1,[r2,#0x28]	;remainder
	bx lr

	END