	GBLL CART_S
	
	INCLUDE equates.h
	INCLUDE import.h
	INCLUDE 6502mac.h

	EXPORT map67_
	EXPORT map89_
	EXPORT mapAB_
	EXPORT mapCD_
	EXPORT mapEF_
	EXPORT map89AB_
	EXPORT mapCDEF_
	EXPORT map89ABCDEF_
	EXPORT initcart
	EXPORT NES_reset
	EXPORT savestate
	EXPORT loadstate	
	EXPORT cartflags
	EXPORT emuflags
	EXPORT rommask
;----------------------------------------------------------------------------
	 AREA |.text|,CODE
mappertbl
	DCD 0,mapper0init
	DCD 1,mapper1init
	DCD 2,mapper2init
	DCD 3,mapper3init
	DCD 4,mapper4init
	DCD 5,mapper5init
	DCD 7,mapper7init
	DCD 9,mapper9init
	DCD 10,mapper10init
	DCD 11,mapper11init
	DCD 15,mapper15init
	DCD 16,mapper16init
	DCD 17,mapper17init
	DCD 18,mapper18init
	DCD 19,mapper19init
	DCD 21,mapper21init
	DCD 22,mapper22init
	DCD 23,mapper23init
	DCD 24,mapper24init
	DCD 25,mapper25init
	DCD 26,mapper26init
	DCD 32,mapper32init
	DCD 33,mapper33init
	DCD 34,mapper34init
	DCD 40,mapper40init
	DCD 64,mapper64init
	DCD 65,mapper65init
	DCD 66,mapper66init
	DCD 67,mapper67init
	DCD 68,mapper68init
	DCD 69,mapper69init
	DCD 70,mapper70init
	DCD 71,mapper71init
	DCD 72,mapper72init
	DCD 73,mapper73init
	DCD 75,mapper75init
	DCD 76,mapper76init
	DCD 77,mapper77init
	DCD 78,mapper78init
	DCD 79,mapper79init
	DCD 80,mapper80init
	DCD 85,mapper85init
	DCD 86,mapper86init
	DCD 87,mapper87init
	DCD 92,mapper92init
	DCD 93,mapper93init
	DCD 94,mapper94init
	DCD 97,mapper97init
	DCD 99,mapper99init
	DCD 105,mapper105init
	DCD 118,mapper4init
	DCD 119,mapper4init
	DCD 151,mapper151init
	DCD 152,mapper152init
	DCD 158,mapper64init
	DCD 180,mapper180init
	DCD 184,mapper184init
	DCD 228,mapper228init
	DCD 232,mapper232init
	DCD -1,mapper0init

rommask DCD 0
romnumber DCD 0
emuflags DCD 0
cartflags DCB 0

	ALIGN
;----------------------------------------------------------------------------
initcart ;called from C:  r0=rom, (r1=emuflags?)
;
;	(initialize mapper, etc after loading the rom)
;----------------------------------------------------------------------------
	stmfd sp!,{r4-r11,lr}

	ldr globalptr,=globals		;init ptr regs
	ldr cpu_zpage,=NES_RAM

	add r3,r0,#16		;skip over iNES header
	str r3,rombase		;set rom base.  r3=rombase til end of initcart so DON'T FUCK IT UP

	;str r1,emuflags

	mov r2,#1
	ldrb r1,[r3,#-12]
	rsb r0,r2,r1,lsl#14
	str r0,rommask		;rommask=romsize-1

	add r0,r3,r1,lsl#14
	str r0,vrombase		;set vrom base

	ldrb r4,[r3,#-11]
	mov r1,r4			;r1=vrom size
	cmp r4,#2
	movhi r1,#4			;needs to be power of 2 (stupid zelda2)
	cmp r4,#4
	movhi r1,#8
	cmp r4,#8
	movhi r1,#16
	cmp r4,#16
	movhi r1,#32
	cmp r4,#32
	movhi r1,#64
	cmp r4,#64
	movhi r1,#128
	rsbs r0,r2,r1,lsl#13
	str r0,vrommask		;vrommask=vromsize-1
	ldrmi r0,=NES_VRAM
	strmi r0,vrombase	;vrombase=NES VRAM if vromsize=0

	ldr r0,=void
	ldrmi r0,=VRAM_chr	;enable/disable chr write
	ldr r1,=vram_write_tbl
	mov r2,#8
	bl filler

	mov m6502_pc,#0		;(eliminates any encodePC errors during mapper*init)
	str m6502_pc,lastbank

	mov r0,#0			;default ROM mapping
	bl map89AB_			;89AB=1st 16k
	mov r0,#-1
	bl mapCDEF_			;CDEF=last 16k

	bl resetCHR			;default CHR mapping

	ldrb r0,[r3,#-10]
	ldrb r1,[r3,#-9]
	and r0,r0,#0x0f
	orr r1,r0,r1,lsl#4
	strb r1,cartflags		;set cartflags

	ldr r0,=pcm_scanlinehook
	str r0,scanlinehook	;no mapper irq

	mov r0,#0xFFFFFFFF		;clear nes ram
	mov r1,cpu_zpage
	mov r2,#0x800/4
	bl filler
	mov r0,#0				;clear nes sram
	add r1,cpu_zpage,#0x800
	mov r2,#0x2000/4
	bl filler
	ldr r1,=mapperstate		;clear mapperdata so we dont have to do that in every MapperInit.
	mov r2,#32/4
	bl filler

	mov r0,#0x7c
	mov r1,cpu_zpage
	ldr r2,=0x247d			;0x7c7d
	strb r0,[r1,r2]			;for "Low G Man".
	add r2,r2,#0x100
	mov r0,#0x7d
	strb r0,[r1,r2]			;for "Low G Man".

	ldr r0,=joy0_W
	ldr r1,=joypad_write_ptr
	str r0,[r1]				;reset 4016 write (mapper99 messes with it)

	ldr r1,=IO_R			;reset other writes..
	str r1,readmem_tbl+8
	ldr r1,=sram_R			;reset other writes..
	str r1,readmem_tbl+12
	ldr r1,=IO_W			;reset other writes..
	str r1,writemem_tbl+8
	ldr r1,=sram_W
	str r1,writemem_tbl+12
	ldr r1,=NES_RAM-0x5800	;$6000 for mapper 40, 69 & 90 that has rom here.
	str r1,memmap_tbl+12

	ldrb r1,[r3,#-10]		;get mapper#
	ldrb r2,[r3,#-9]
	tst r2,#0x0e			;long live DiskDude!
	and r1,r1,#0xf0
	and r2,r2,#0xf0
	orr r0,r2,r1,lsr#4
	movne r0,r1,lsr#4		;ignore high nibble if header looks bad
							;lookup mapper*init
	adr r1,mappertbl
lc0	ldr r2,[r1],#8
	teq r2,r0
	beq lc1
	bpl lc0
lc1				;call mapperXXinit
	adr r5,writemem_tbl+16
	ldr r0,[r1,#-4]
	ldmia r0!,{r1-r4}
	stmia r5,{r1-r4}
	blx r0

	ldrb r1,cartflags
	tst r1,#MIRROR		;set default mirror
	bl mirror2H_		;(call after mapperinit to allow mappers to set up cartflags first)

	bl NES_reset
	bl recorder_reset	;init rewind control stuff
	
	ldmfd sp!,{r4-r11,pc}
;----------------------------------------------------------------------------
savestate
;int savestate(void *here): copy state to <here>, return size
;----------------------------------------------------------------------------
	stmfd sp!,{r4-r6,globalptr,lr}

	ldr globalptr,=globals

	ldr r2,rombase
	rsb r2,r2,#0			;adjust rom maps,etc so they aren't based on rombase
	bl fixromptrs

	mov r6,r0			;r6=where to copy state
	mov r0,#0			;r0 holds total size (return value)

	adr r4,savelst			;r4=list of stuff to copy
	mov r3,#(lstend-savelst)/8	;r3=items in list
ss1	ldr r2,[r4],#4				;r2=what to copy
	ldr r1,[r4],#4				;r1=how much to copy
	add r0,r0,r1
ss0	ldr r5,[r2],#4
	str r5,[r6],#4
	subs r1,r1,#4
	bne ss0
	subs r3,r3,#1
	bne ss1

	ldr r2,rombase			;restore pointers
	bl fixromptrs

	ldmfd sp!,{r4-r6,globalptr,pc}

savelst DCD NES_RAM,0x2800
	DCD NES_VRAM,0x3000
	DCD agb_pal,96
	DCD vram_map,64
	DCD agb_nt_map,16
	DCD mapperstate,32
	DCD rommap,16
	DCD cpustate,44
	DCD ppustate,48
lstend
;c_defs: #define SAVESTATESIZE (0x2800+0x3000+96+64+16+32+16+44+48)

fixromptrs	;add r2 to some things
	adr r1,memmap_tbl+16
	ldmia r1,{r3-r6}
	add r3,r3,r2
	add r4,r4,r2
	add r5,r5,r2
	add r6,r6,r2
	stmia r1,{r3-r6}

	ldr r3,lastbank
	add r3,r3,r2
	str r3,lastbank

	ldr r3,cpuregs+6*4	;6502 PC
	add r3,r3,r2
	str r3,cpuregs+6*4

	mov pc,lr
;----------------------------------------------------------------------------
loadstate
;void loadstate(u32 *stateptr)	 (stateptr must be word aligned)
;----------------------------------------------------------------------------
	stmfd sp!,{r0,r4-r7,globalptr,lr}

	ldr globalptr,=globals
	bl resetCHR
	ldmfd sp!,{r6}			;r6=where state is at

	mov r0,#(lstend-savelst)/8	;read entire state
	adr r4,savelst
ls1	ldr r2,[r4],#4
	ldr r1,[r4],#4
ls0	ldr r5,[r6],#4
	str r5,[r2],#4
	subs r1,r1,#4
	bne ls0
	subs r0,r0,#1
	bne ls1

	ldr r2,rombase		;adjust ptr shit (see savestate above)
	bl fixromptrs
;---
	ldr r3,=NES_VRAM+0x2000		;write all nametbl + attrib
	ldr r4,=NDS_BG
ls4	mov r5,#0
ls3	mov r1,r3
	mov r2,r4
	mov addy,r5
	ldrb r0,[r1,addy]
	bl writeBG
	add r5,r5,#1
	cmp r5,#0x400
	bne ls3
	add r3,r3,#0x400
	add r4,r4,#0x800
	tst r4,#0x1800
	bne ls4
;---
	;ldr r0,nes_chr_map		;init BG CHR
	;bl bg_chr_req
	;ldr r0,nes_chr_map+4
	;bl bg_chr_req
	bl updateBGCHR
	ldrb r0,ppuctrl1
	bl ctrl1_W

	ldmfd sp!,{r4-r7,globalptr,pc}
;----------------------------------------------------------------------------
NES_reset
;----------------------------------------------------------------------------
	stmfd sp!,{r4-r11,lr}

	ldr globalptr,=globals		;need this?
	ldr cpu_zpage,=NES_RAM

	bl PPU_reset
	bl IO_reset
	bl Sound_reset
	bl CPU_reset
	
	ldmfd sp!,{r4-r11,pc}
;----------------------------------------------------------------------------
map67_	;rom paging.. r0=page#
;----------------------------------------------------------------------------
	ldr r1,rommask
	and r0,r1,r0,lsl#13
	ldr r1,rombase
	add r0,r1,r0
	sub r0,r0,#0x6000
	str r0,memmap_tbl+12
	b flush
;----------------------------------------------------------------------------
map89_	;rom paging.. r0=page#
;----------------------------------------------------------------------------
	ldr r1,rombase
	sub r1,r1,#0x8000
	ldr r2,rommask
	and r0,r2,r0,lsl#13
	add r0,r1,r0
	str r0,memmap_tbl+16
	b flush
;----------------------------------------------------------------------------
mapAB_
;----------------------------------------------------------------------------
	ldr r1,rombase
	sub r1,r1,#0xa000
	ldr r2,rommask
	and r0,r2,r0,lsl#13
	add r0,r1,r0
	str r0,memmap_tbl+20
	b flush
;----------------------------------------------------------------------------
mapCD_
;----------------------------------------------------------------------------
	ldr r1,rombase
	sub r1,r1,#0xc000
	ldr r2,rommask
	and r0,r2,r0,lsl#13
	add r0,r1,r0
	str r0,memmap_tbl+24
	b flush
;----------------------------------------------------------------------------
mapEF_
;----------------------------------------------------------------------------
	ldr r1,rombase
	sub r1,r1,#0xe000
	ldr r2,rommask
	and r0,r2,r0,lsl#13
	add r0,r1,r0
	str r0,memmap_tbl+28
	b flush
;----------------------------------------------------------------------------
map89AB_
;----------------------------------------------------------------------------
	ldr r1,rombase
	sub r1,r1,#0x8000
	ldr r2,rommask
	and r0,r2,r0,lsl#14
	add r0,r1,r0
	str r0,memmap_tbl+16
	str r0,memmap_tbl+20
flush		;update m6502_pc & lastbank
	ldr r1,lastbank
	sub m6502_pc,m6502_pc,r1
	encodePC
	mov pc,lr
;----------------------------------------------------------------------------
mapCDEF_
;----------------------------------------------------------------------------
	ldr r1,rombase
	sub r1,r1,#0xc000
	ldr r2,rommask
	and r0,r2,r0,lsl#14
	add r0,r1,r0
	str r0,memmap_tbl+24
	str r0,memmap_tbl+28
	b flush
;----------------------------------------------------------------------------
map89ABCDEF_
;----------------------------------------------------------------------------
	ldr r1,rombase
	sub r1,r1,#0x8000
	ldr r2,rommask
	and r0,r2,r0,lsl#15
	add r0,r1,r0
	str r0,memmap_tbl+16
	str r0,memmap_tbl+20
	str r0,memmap_tbl+24
	str r0,memmap_tbl+28
	b flush
;----------------------------------------------------------------------------
	END
