		GBLL DEBUG
DEBUG		SETL {TRUE}
;----------------------------------------------------------------------------

IPC			EQU 0x27fff00
IPC_TOUCH_X		EQU IPC+0
IPC_TOUCH_Y		EQU IPC+2
IPC_KEYS		EQU IPC+4
IPC_ALIVE		EQU IPC+8
IPC_TMP0		EQU IPC+12
IPC_TMP1		EQU IPC+16
IPC_APU_WRITE_HEAD	EQU IPC+20
IPC_APU_WRITE_TAIL	EQU IPC+24

KEY_A			EQU 1
KEY_B			EQU 2
KEY_SELECT		EQU 4
KEY_START		EQU 8
KEY_RIGHT		EQU 16
KEY_LEFT		EQU 32
KEY_UP			EQU 64
KEY_DOWN		EQU 128
KEY_R			EQU 256
KEY_L			EQU 512
KEY_X			EQU 1024
KEY_Y			EQU 2048

		;DMA buffers go in high RAM - stay below 27ffc00 (firmware settings)

SOUNDBUFF		EQU 0x27ffc00-256*4	;see c_defs.h
BGCNTBUFF		EQU SOUNDBUFF-240*16
DISPCNTBUFF		EQU BGCNTBUFF-240*2	;27fe720

		;miscellaneous stuff (don't go past 23fe000)
		
NES_RAM			EQU 0x23f8000		;keep $400 byte aligned for 6502 stack
NES_SRAM		EQU NES_RAM+0x0800	;***!!! also in c_defs.h
CHR_DECODE		EQU NES_SRAM+0x2000
NES_VRAM		EQU CHR_DECODE+0x400
MAPPED_RGB		EQU NES_VRAM+0x3000	;mapped NES palette (for VS unisys)
;?			EQU MAPPED_RGB+64*3
			
NDS_PALETTE		EQU 0x5000000
NDS_VRAM		EQU 0x6000000
NDS_SRAM		EQU 0xA000000
NDS_OAM			EQU 0x7000000
NDS_BG			EQU 0x605e000
NDS_OBJVRAM		EQU 0x6400000
;-----------

REG_BASE		EQU 0x4000000
REG_DISPCNT		EQU 0x00
REG_DISPSTAT		EQU 0x04
REG_BG0CNT		EQU 0x08
REG_BG0HOFS		EQU 0x10
;REG_BG0VOFS		EQU 0x12
;REG_BG1HOFS		EQU 0x14
;REG_BG1VOFS		EQU 0x16
REG_DM0SAD		EQU 0xB0
REG_DM0DAD		EQU 0xB4
REG_DM0CNT_L		EQU 0xB8
REG_DM0CNT_H		EQU 0xBA
REG_DM1SAD		EQU 0xBC
REG_DM1DAD		EQU 0xC0
REG_DM1CNT_L		EQU 0xC4
REG_DM1CNT_H		EQU 0xC6
REG_DM2SAD		EQU 0xC8
REG_DM2DAD		EQU 0xCC
REG_DM2CNT_L		EQU 0xD0
REG_DM2CNT_H		EQU 0xD2
REG_DM3SAD		EQU 0xD4
REG_DM3DAD		EQU 0xD8
REG_DM3CNT_L		EQU 0xDC
REG_DM3CNT_H		EQU 0xDE
REG_IME			EQU 0x208
REG_IE			EQU 0x210
REG_IF			EQU 0x214
REG_WININ		EQU 0x48
REG_WINOUT		EQU 0x4A
REG_WIN0H		EQU 0x40
REG_WIN0V		EQU 0x44
REG_WIN1H		EQU 0x42
REG_WIN1V		EQU 0x46
REG_BLDCNT		EQU 0x50
REG_BLDALPHA		EQU 0x52

		;r0,r1,r2=temp regs
m6502_nz	RN r3 ;bit 31=N, Z=1 if bits 0-7=0
m6502_rmem	RN r4 ;readmem_tbl
m6502_a		RN r5 ;bits 0-23=0, also used to clear bytes in memory
m6502_x		RN r6 ;bits 0-23=0
m6502_y		RN r7 ;bits 0-23=0
cycles		RN r8 ;also VDIC flags
m6502_pc	RN r9
globalptr	RN r10 ;=wram_globals* ptr
m6502_optbl	RN r10
cpu_zpage	RN r11 ;=CPU_RAM
addy		RN r12 ;keep this at r12 (scratch for APCS)
		;r13=SP
		;r14=LR
		;r15=PC
;----------------------------------------------------------------------------

 MAP 0,cpu_zpage
nes_ram # 0x800
nes_sram # 0x2000
chr_decode # 0x400

;everything in wram_globals* areas:

 MAP 0,globalptr	;6502.s
opz # 256*4
readmem_tbl # 8*4
writemem_tbl # 8*4
memmap_tbl # 8*4
cpuregs # 7*4
m6502_s # 4
lastbank # 4
nexttimeout # 4
scanline # 4
scanlinehook # 4
frame # 4
cyclesperscanline # 4
lastscanline # 4
unused_align # 4
			;ppu.s
fpsvalue # 4
adjustblend # 4
 ;ppustate:
vramaddr # 4
vramaddr2 # 4
scrollX # 4
scrollY # 4
scrollYtemp # 4
sprite0y # 4
readtemp # 4
bg0cnt # 4
sprite0x # 1
vramaddrinc # 1
ppustat # 1
toggle # 1
ppuctrl0 # 1
ppuctrl0frame # 1
ppuctrl1 # 1
ppuoamadr # 1
nes_chr_map # 8
			;cart.s
mapperdata # 32
rombase # 4

;----------------------------------------------------------------------------
IRQ_VECTOR		EQU 0xfffe ; IRQ/BRK interrupt vector address
RES_VECTOR		EQU 0xfffc ; RESET interrupt vector address
NMI_VECTOR		EQU 0xfffa ; NMI interrupt vector address
;-----------------------joyflags
P1_ENABLE		EQU 0x10000
P2_ENABLE		EQU 0x20000
B_A_SWAP		EQU 0x80000
L_R_DISABLE		EQU 0x100000
AUTOFIRE		EQU 0x1000000
;-----------------------cartflags
MIRROR			EQU 0x01 ;horizontal mirroring
SRAM			EQU 0x02 ;save SRAM
TRAINER			EQU 0x04 ;trainer present
SCREEN4			EQU 0x08 ;4way screen layout
VS			EQU 0x10 ;VS unisystem
;-----------------------emuflags (keep c_defs.h updated)

NOFLICKER		EQU 1	;flags&3:  0=flicker 1=noflicker 2=alphalerp
ALPHALERP		EQU 2
PALTIMING		EQU 4	;0=NTSC 1=PAL
FOLLOWMEM		EQU 32  ;0=follow sprite, 1=follow mem
;?			EQU 64
;?			EQU 128

				;bits 8-15=scale type

UNSCALED_NOAUTO	EQU 0	;display types
UNSCALED_AUTO	EQU 1
SCALED		EQU 2
SCALED_SPRITES	EQU 3

				;bits 16-31=sprite follow val

;----------------------------------------------------------------------------
CYC_SHIFT		EQU 8
CYCLE			EQU 1<<CYC_SHIFT ;one cycle (341*CYCLE cycles per scanline)

;cycle flags- (stored in cycles reg for speed)

CYC_C			EQU 0x01	;Carry bit
BRANCH			EQU 0x02	;branch instruction encountered
CYC_I			EQU 0x04	;IRQ mask
CYC_D			EQU 0x08	;Decimal bit
CYC_V			EQU 0x40	;Overflow bit
CYC_MASK		EQU CYCLE-1	;Mask
;------------------------------------------------------------------------------
 [ DEBUG
	IMPORT debuginfo
 ]

ERR0	EQU 0
ERR1	EQU 1
READ	EQU 2
WRITE	EQU 3
BRK	EQU 4
BADOP	EQU 5
VBLS	EQU 6
FPS	EQU 7
BGMISS	EQU 8

	MACRO
	DEBUGINFO $index,$reg
 [ DEBUG
	stmfd sp!,{r9}
	ldr r9,=debuginfo
	str $reg,[r9,#$index*4]
	ldmfd sp!,{r9}
 ]
	MEND

	MACRO
	DEBUGCOUNT $index
 [ DEBUG
	stmfd sp!,{r9-r10}
	ldr r9,=debuginfo
	ldr r10,[r9,#$index*4]
	add r10,r10,#1
	str r10,[r9,#$index*4]
	ldmfd sp!,{r9-r10}
 ]
	MEND

	MACRO
	DEBUGERROR $addr,$reg
	DEBUGINFO ERR0,$reg
 [ DEBUG
	ldr r1,=$addr
 ]
	DEBUGINFO ERR1,r1
	MEND

	MACRO
	SET_PID $reg
 [ DEBUG
 	mcr p15,0,$reg,c13,c0,1
 ]
 	MEND

;----------------
	END
