	GBLL IO_S
	
	INCLUDE equates.h
	INCLUDE import.h

	EXPORT IO_reset
	EXPORT IO_R
	EXPORT IO_W
	EXPORT joypad_write_ptr
	EXPORT joy0_W
	EXPORT joyflags
	EXPORT refreshNESjoypads
	EXPORT spriteY_lookup
	EXPORT joystate
				
	AREA |.text|,CODE
;----------------------------------------------------------------------------
IO_reset
;----------------------------------------------------------------------------
	mov pc,lr
;----------------------------------------------------------------------------
IO_R		;I/O read
;----------------------------------------------------------------------------
	sub r2,addy,#0x4000
	subs r2,r2,#0x15
	bmi empty_R
	cmp r2,#3
	ldrmi pc,[pc,r2,lsl#2]
	b empty_R
io_read_tbl
	DCD _4015r	;4015 (sound)
	DCD joy0_R	;4016: controller 1
	DCD joy1_R	;4017: controller 2
;----------------------------------------------------------------------------
IO_W		;I/O write
;----------------------------------------------------------------------------
	sub r2,addy,#0x4000
	cmp r2,#0x18
	ldrmi pc,[pc,r2,lsl#2]
	b empty_W
io_write_tbl
	DCD soundwrite
	DCD soundwrite
	DCD soundwrite
	DCD soundwrite
	DCD soundwrite
	DCD soundwrite
	DCD soundwrite
	DCD soundwrite
	DCD soundwrite
	DCD soundwrite
	DCD soundwrite
	DCD soundwrite
	DCD soundwrite
	DCD soundwrite
	DCD soundwrite
	DCD soundwrite
	DCD soundwrite
	DCD soundwrite
	DCD soundwrite
	DCD soundwrite
	DCD dma_W	;$4014: Sprite DMA transfer
	DCD soundwrite
joypad_write_ptr
	DCD joy0_W	;$4016: Joypad 0 write
	DCD void	;$4017: ?
;----------------------------------------------------------------------------
dma_W	;(4014)		sprite DMA transfer
;----------------------------------------------------------------------------
PRIORITY EQU 0x000	;0x800=AGB OBJ priority 2/3

	ldr r1,=3*512*CYCLE		; was 514...
	sub cycles,cycles,r1
	stmfd sp!,{r3-r8,lr}

	and r1,r0,#0xe0
	adr addy,memmap_tbl
	ldr addy,[addy,r1,lsr#3]
	and r0,r0,#0xff
	add addy,addy,r0,lsl#8	;addy=DMA source

	ldr r0,=emuflags		;r7,8=priority flags for scaling type
	ldr r0,[r0]
	tst r0,#ALPHALERP
	moveq r7,#0x00200000
	movne r7,#0
	eor r8,r7,#0x00200000
	
	ldr r2,=NDS_OAM
dm0
	adr r5,spriteY_lookup

	ldrb r0,ppuctrl0frame	;8x16?
	tst r0,#0x20
	bne dm4
;- - - - - - - - - - - - - 8x8 size
							;get sprite0 hit pos:
	tst r0,#0x08			;CHR base? (0000/1000)
	moveq r4,#0+PRIORITY	;r4=CHR set+AGB priority
	movne r4,#0x100+PRIORITY
	ldrb r0,[addy,#1]		;sprite tile#
	ldr r1,=NDS_OBJVRAM
	addne r1,r1,#0x2000
	add r0,r1,r0,lsl#5		;r0=VRAM base+tile*32
	ldr r1,[r0]				;I dont really give a shit about Y flipping at the moment
	cmp r1,#0
	ldreq r1,[r0,#4]!
	cmpeq r1,#0
	ldreq r1,[r0,#4]!
	cmpeq r1,#0
	ldreq r1,[r0,#4]!
	cmpeq r1,#0
	ldreq r1,[r0,#4]!
	cmpeq r1,#0
	ldreq r1,[r0,#4]!
	cmpeq r1,#0
	ldreq r1,[r0,#4]!
	cmpeq r1,#0
	ldreq r1,[r0,#4]!
	cmpeq r1,#0
	and r0,r0,#31
	ldrb r1,[addy]			;r1=sprite0 Y
	add r1,r1,#1
	add r1,r1,r0,lsr#2
;	moveq r1,#512			;blank tile=no hit
	cmp r1,#239
	movhi r1,#512			;no hit if Y>239
	str r1,sprite0y
;	ldrb r1,[addy,#3]		;r1=sprite0 x
;	strb r1,sprite0x
dm11
	ldr r3,[addy],#4
	and r0,r3,#0xff
	cmp r0,#239
	bhi dm10			;skip if sprite Y>239
	ldrb r0,[r5,r0]			;r0=scaled y

	mov r1,r3,lsr#24
	orr r0,r0,r1,lsl#16	;sprite x
	
	and r1,r3,#0x00c00000	;flip
	orr r0,r0,r1,lsl#6

	and r1,r3,r7		;priority
	orr r0,r0,r1,lsr#11		;Set Transp OBJ. (for non-alpha)

	str r0,[r2],#4			;store OBJ Atr 0,1

	and r1,r3,#0x0000ff00		;tile#
	and r0,r3,#0x00030000		;color
	orr r0,r1,r0,lsl#4
	orr r0,r4,r0,lsr#8		;tileset

	tst r3,r8
	orrne r0,r0,#0x0400		;priority (for alpha)

	strh r0,[r2],#4			;store OBJ Atr 2
dm9
	tst addy,#0xff
	bne dm11
	ldmfd sp!,{r3-r8,pc}
dm10
	mov r0,#0x2a0			;double, y=160
	str r0,[r2],#8
	b dm9

dm4	;- - - - - - - - - - - - - 8x16 size
				;check sprite hit:
	ldrb r0,[addy,#1]		;sprite tile#
	movs r0,r0,lsr#1
	orrcs r0,r0,#0x80
	ldr r1,=NDS_OBJVRAM
	add r0,r1,r0,lsl#6
	ldr r1,[r0]
	cmp r1,#0
	ldreq r1,[r0,#4]!
	cmpeq r1,#0
	ldreq r1,[r0,#4]!
	cmpeq r1,#0
	ldreq r1,[r0,#4]!
	cmpeq r1,#0
	ldreq r1,[r0,#4]!
	cmpeq r1,#0
	ldreq r1,[r0,#4]!
	cmpeq r1,#0
	ldreq r1,[r0,#4]!
	cmpeq r1,#0
	ldreq r1,[r0,#4]!
	cmpeq r1,#0
	ldreq r1,[r0,#4]!
	cmpeq r1,#0
	ldreq r1,[r0,#4]!
	cmpeq r1,#0
	ldreq r1,[r0,#4]!
	cmpeq r1,#0
	ldreq r1,[r0,#4]!
	cmpeq r1,#0
	ldreq r1,[r0,#4]!
	cmpeq r1,#0
	ldreq r1,[r0,#4]!
	cmpeq r1,#0
	ldreq r1,[r0,#4]!
	cmpeq r1,#0
	ldreq r1,[r0,#4]!
	cmpeq r1,#0
	and r0,r0,#63
	ldrb r1,[addy]			;r1=sprite0 Y
	add r1,r1,#1
	add r1,r1,r0,lsr#2
;	moveq r1,#512			;blank tile=no hit
	cmp r1,#239
	movhi r1,#512			;no hit if Y>239
	str r1,sprite0y
;	ldrb r1,[addy,#3]		;r1=sprite0 x
;	strb r1,sprite0x

	mov r4,#PRIORITY
dm12
	ldr r3,[addy],#4
	and r0,r3,#0xff
	cmp r0,#239
	bhi dm13				;skip if sprite Y>239
	ldrb r0,[r5,r0]				;r0=scaled y
		
	mov r1,r3,lsr#24
	orr r0,r0,r1,lsl#16	;sprite x

	and r1,r3,#0x00c00000	;flip
	orr r0,r0,r1,lsl#6

	and r1,r3,r7		;priority
	orr r0,r0,r1,lsr#11		;Set Transp OBJ. (for non-alpha)

	orr r0,r0,#0x8000		;8x16
	str r0,[r2],#4			;store OBJ Atr 0,1

	and r1,r3,#0x0000ff00	;tile#
	movs r0,r1,lsr#9
	orrcs r0,r0,#0x80
	orr r0,r4,r0,lsl#1		;priority, tile#*2
	and r1,r3,#0x00030000	;color
	orr r0,r0,r1,lsr#4

	tst r3,r8
	orrne r0,r0,#0x0400		;priority (for alpha)

	strh r0,[r2],#4			;store OBJ Atr 2
dm14
	tst addy,#0xff
	bne dm12
	ldmfd sp!,{r3-r8,pc}
dm13
	mov r0,#0x2a0			;double, y=160
	str r0,[r2],#8
	b dm14
	
spriteY_lookup % 256
;----------------------------------------------------------------------------
refreshNESjoypads	;call every frame
;----------------------------------------------------------------------------
	ldr r1,=IPC_KEYS
	ldr r1,[r1]

	;-> R L D U St Sl B A

	ldr r2,joyflags
	mov r0,#0

	tst r2,#B_A_SWAP		;swap buttons?
	bne rj0
		tst r1,#KEY_B
		orrne r0,r0,#1
		tst r2,#AUTOFIRE	;auto?
		tstne r1,#KEY_A
		eorne r0,r0,#1	

		tst r1,#KEY_Y
		orrne r0,r0,#2
		tst r2,#AUTOFIRE
		tstne r1,#KEY_X
		orrne r0,r0,#2
	b rj1
rj0
		tst r1,#KEY_A
		orrne r0,r0,#1
		tst r2,#AUTOFIRE
		tstne r1,#KEY_X
		eorne r0,r0,#1	

		tst r1,#KEY_B
		orrne r0,r0,#2
		tst r2,#AUTOFIRE
		tstne r1,#KEY_Y
		orrne r0,r0,#2
rj1
	tst r1,#KEY_SELECT
	orrne r0,r0,#4
	tst r1,#KEY_START
	orrne r0,r0,#8
	tst r1,#KEY_UP
	orrne r0,r0,#16
	tst r1,#KEY_DOWN
	orrne r0,r0,#32
	tst r1,#KEY_LEFT
	orrne r0,r0,#64
	tst r1,#KEY_RIGHT
	orrne r0,r0,#128
	
	eor r2,r2,#AUTOFIRE	;toggle autofire state
	str r2,joyflags

	tst r2,#P1_ENABLE
	orrne r2,r2,r0
	tst r2,#P2_ENABLE
	orrne r2,r2,r0,lsl#8
	strh r2,joystate

	bx lr

joyflags	DCD P1_ENABLE	;d0-7=pad0, d8-15=pad1, others=flags

joystate
joy0state DCB 0
joy1state DCB 0
;joy2state DCB 0
;joy3state DCB 0
joy0serial DCD 0
joy1serial DCD 0
;nrplayers DCD 0	;Number of players in multilink.
;----------------------------------------------------------------------------
joy0_W		;4016
;----------------------------------------------------------------------------
	tst r0,#1
	movne pc,lr
	;ldr r2,nrplayers
	;cmp r2,#3
	mov r2,#-1

	ldrb r0,joy0state
	;ldrb r1,joy2state
	;orr r0,r0,r1,lsl#8
	orr r0,r0,r2,lsl#8	;for normal joypads.
	;orrpl r0,r0,#0x00080000	;4player adapter
	str r0,joy0serial

	ldrb r0,joy1state
	;ldrb r1,joy3state
	;orr r0,r0,r1,lsl#8
	orr r0,r0,r2,lsl#8	;for normal joypads.
	;orrpl r0,r0,#0x00040000	;4player adapter
	str r0,joy1serial
	mov pc,lr
;----------------------------------------------------------------------------
joy0_R		;4016
;----------------------------------------------------------------------------
	ldr r0,joy0serial
	mov r1,r0,asr#1
	and r0,r0,#1
	str r1,joy0serial

	ldr r2,=cartflags
	ldrb r1,[r2]
	tst r1,#VS
	orreq r0,r0,#0x40
	moveq pc,lr

	ldrb r1,joy0state
	tst r1,#8		;start=coin (VS)
	orrne r0,r0,#0x40

	mov pc,lr
;----------------------------------------------------------------------------
joy1_R		;4017
;----------------------------------------------------------------------------
	ldr r0,joy1serial
	mov r1,r0,asr#1
	and r0,r0,#1
	str r1,joy1serial

	ldr r2,=cartflags
	ldrb r1,[r2]
	tst r1,#VS
	orrne r0,r0,#0xf8	;VS dip switches
	mov pc,lr
;----------------------------
	END