#include <NDS/nds.h>
#include <string.h>
#include <ds_misc.h>
#include "c_defs.h"


touchstring scaleopts[]={
	{64*20+2,"  Flicker"}, {64*22+2,"  None"}, {64*18+2,"  \x7F-lerp"},
	{64*12+26,"\x80"}, {64*12+36,"\x81"}, {64*11+30,"\x84\x85"}, {64*14+30,"\x86\x87"},{64*23-10,"Exit"},{-1,0}};
int adjustdisplay() {
	static int scale=0xe000, ypos=-0x00060000, dragging=0;
	int i,j;
	u32 dts;
	
	consoletext(64*4+0,"Touch anywhere to adjust screen.",0);
	consoletext(64*5+4,"Use arrows for fine control.",0);
	consoletext(64*16+2,"Blend type:",0);

	scaleopts[0].str[0]=' ';
	scaleopts[1].str[0]=' ';
	scaleopts[2].str[0]=' ';
	scaleopts[emuflags&3].str[0]='*';

	dts=do_touchstrings(scaleopts,0);
	if(touchstate==2 && dts==-1 && !(last_x>88 && last_x<168 && last_y>72 && last_y<128) && last_y>24) {	//pen down, no strings hit, outside of arrow box
		dragging=1;
	}

	if(dragging) {
		if(touchstate==4) {
			dragging=0;
			touchstate=0;	//hide touch input from tab+exit text
		} else {
			i=IPC_TOUCH_X-24;
			if(i<0) i=0;
			if(i>207) i=207;
			i*=48;
			i/=208;
			i+=192;			//i=192..239

			j=IPC_TOUCH_Y;
			j*=(239-i);
			j/=192;
			j=-j;

			i=(192*65536)/i;
			
			scale=i;
			ypos=j<<16;
			touchstate=3;	//hide touch input from tab+exit text
		}
	} else {
		switch(dts) {
			case 0: //alpha
			case 1: //flicker
			case 2: //none
				if(touchstate==4)
					emuflags=(emuflags&~3)|dts;
				break;
			case 3: //left
				scale++;
				break;
			case 4: //right
				scale--;
				break;
			case 5: //up
				ypos+=0x100;
				break;
			case 6: //down
				ypos-=0x100;
				break;
		}
	}

	if(touchstate>1)
		rescale(scale,ypos);
	hex16(64*12+28,scale);
	hex16(64*13+28,ypos>>8);
	
	return 0;
}

/////////////////////////////

#define P1 (64*7+18)
#define P2 (64*15+18)
#define LOCK 0x40000
char B_btn[]="Y";
char A_btn[]="B";
char LRdisabled[]="L+R disabled";
char LRenabled[]="L+R enabled ";
touchstring controls[]={
	{P1+28,A_btn},{P1+24,B_btn},{P1+14,"\x88"}, {P1+18,"\x88"}, {P1-124,"\x82"}, {P1+132,"\x83"}, {P1,"\x80"}, {P1+8,"\x81"},
	{P2+28,A_btn},{P2+24,B_btn},{P2+14,"\x88"}, {P2+18,"\x88"}, {P2-124,"\x82"}, {P2+132,"\x83"}, {P2,"\x80"}, {P2+8,"\x81"},
	{P1-110,"Enable"},{P2-110,"Enable"},{P1+256-12,"Lock"},{64*20+2,"B+A change"},{64*22+2,LRenabled},{64*22+34,"Reset"},{-1,0}};
int do_touchcontroller() {
	u32 flags, i;
	
	flags=joyflags;
	if(flags&B_A_SWAP) {
		*B_btn='B';
		*A_btn='A';
	} else {
		*B_btn='Y';
		*A_btn='B';
	}
	if(flags&L_R_DISABLE) {
		controls[20].str=LRdisabled;
	} else {
		controls[20].str=LRenabled;
	}
	if(!(flags&LOCK))
		flags&=~0xffff;
		
	i=do_touchstrings(controls,joystate | (flags&0x70000));
	if(touchstate==4) {
		if(i<21) {
			flags^=1<<i;
		} else if(i==21) {
			NES_reset();
		}	
	} else {
		if(i<16 && !(flags&LOCK))
			flags|=1<<i;
	}
	
	joyflags=flags;
	return 0;
}

/////////////////////////

extern u32 agb_bg_map[];
u32 debuginfo[16];
char *debugtxt[]={
"ERR0","ERR1","READ","WRITE","BRK","BAD OP","VBLS","FPS",
"BGMISS","9","a","b","c","ALIVE","TMP0","TMP1"};
#define DLINE 4
int debugdump() {
/*
	int i;
	u32 *p;
	char **cc;

	debuginfo[13]=IPC_ALIVE;
	debuginfo[14]=IPC_TMP0;
	debuginfo[15]=IPC_TMP1;
	
	p=debuginfo;
	cc=debugtxt;
	for(i=64*DLINE;i<64*(DLINE+16);i+=64) {
		consoletext(i,*cc++,0);
		hex32(i+14,*p++);
	}

	p=agb_bg_map;
	for(i=64*DLINE;i<64*(DLINE+16);i+=64) {
		hex32(i+32,*p++);
	}
	
	hex32(64*22,freemem_end-freemem_start);
	consoletext(64*22+18,"bytes free",0);
	consoletext(64*23,"Built",0);
	consoletext(64*23+12,__TIME__,0);
	consoletext(64*23+30,__DATE__,0);
	return 0;
*/
	int i;
	u32 *p=(u32*)&mapperstate;//0x7000000;
	for(i=0;i<64;i++) {
		hex32(64*3+i*16,p[i*2]);
	}
	return 0;

}

//////////////////////////////

touchstring savetext[]={
	{64*5+2,"Load ROM"},{64*9+2,"Save state"},{64*13+2,"Load state"},{64*17+2,"Save SRAM"},{-1,0}};
int savestuff() {
	int i;
	
	i=do_touchstrings(savetext,0);
	if(touchstate==4) {
		switch(i) {
			case 0: //load rom
				fifo_send(FIFO_APU_PAUSE,0);
				do_rommenu();
				break;
			case 1: //save state
				write_savestate();
				break;
			case 2: //load state
				read_savestate();	//not to be confused with loadstate/savestate :P
				break;
			case 3: //save SRAM
				save_sram();
				break;
//			case 4: //save settings
//				break;
		}
	}
	return 0;
}